;=======================================================================
macro fat12 [_entry,_name,_lbl]
{
;-----------------------------------------------------------------------
common
    fat:
        db 0F0h,0FFh,0FFh
;-----------------------------------------------------------------------
forward
    fat_offset = ($ - fat)
    init_claster = (fat_offset * 2) / 3
    _lbl#_init = init_claster
    if (_lbl#_size and 511) eq 0
        _count = (_lbl#_size shr 9) 
    else
        _count = (_lbl#_size shr 9) + 1
    end if
    _cycle = (_count - 1) shr 1
    if _cycle > 0
      repeat _cycle
        c_value = (init_claster - 1 + % * 2) or \
                 ((init_claster + % * 2) shl 12)
        dw c_value and 0FFFFh
        db c_value shr 16
      end repeat    
    end if
    if (_count and 1)
        db 0FFh,0Fh,00h        
    else
        c_value = (fat_offset * 2) / 3 + 1
        db  c_value and 255
        db (c_value shr 8) or 0F0h
        db 0FFh 
    end if
common
    rb _sf * _bs + fat - $
    
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
common
    fat1:
        db 0F0h,0FFh,0FFh
;-----------------------------------------------------------------------
forward
    fat_offset = ($ - fat1)
    init_claster = (fat_offset * 2) / 3
    _lbl#_init = init_claster
    if (_lbl#_size and 511) eq 0
        _count = (_lbl#_size shr 9) 
    else
        _count = (_lbl#_size shr 9) + 1
    end if
    _cycle = (_count - 1) shr 1 
    if _cycle > 0
      repeat _cycle
        c_value = (init_claster - 1 + % * 2) or \
                 ((init_claster + % * 2) shl 12)
        dw c_value and 0FFFFh
        db c_value shr 16
      end repeat    
    end if
    if (_count and 1)
        db 0FFh,0Fh,00h        
    else
        c_value = (fat_offset * 2) / 3 + 1
        db  c_value and 255
        db (c_value shr 8) or 0F0h
        db 0FFh 
    end if
common
    rb _sf * _bs + fat1 - $    
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
common
    dir:
;-----------------------------------------------------------------------
forward
    db _entry       ; name
    db 0            ; attr
    rb 14
    dw _lbl#_init
    dd _lbl#_size
;-----------------------------------------------------------------------
common
    rb _rd * 32 + dir - $     
;-----------------------------------------------------------------------
file_area:
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
forward
;-----------------------------------------------------------------------
_lbl#_file: file _name
;-----------------------------------------------------------------------
_lbl#_size = $ - _lbl#_file
;-----------------------------------------------------------------------
spc = ($ - file_area) and (_bs * 2 - 1)
    if spc
        rb _bs * 2 - spc
    end if    
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
common
;-----------------------------------------------------------------------
    db  _bs * _hd * _st * _tr + 7C00h - $ dup (0)
;-----------------------------------------------------------------------
}
;=======================================================================
