;=======================================================================
 format PE GUI 4.0
;=======================================================================
include "win32a.inc"    ;*
include "xx.inc"
include "rc.inc"        ;*
include "bv.inc"        ;*
;=======================================================================
;
;=======================================================================
section '.code' code readable executable

entry $

    invoke GetModuleHandle,0
    mov [hInstance],eax
    invoke DialogBoxParam,[hInstance],D_TRAY,0,d_tray,0
    invoke ExitProcess,0
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
winproc d_tray
;-----------------------------------------------------------------------
    cmp [uMsg],WM_CLOSE
    je .hide
;=======================================================================
    cmp [uMsg],WM_SHELLNOTIFY
    jne @F
    cmp [lParam],WM_RBUTTONDOWN
    je  .menu
    cmp [lParam],WM_LBUTTONDOWN
    je  .vis
    cmp [lParam],WM_LBUTTONDBLCLK
    jne @F
.show_hide:
    cmp [fShow],0
    jne .hide
.show:
    mov [fShow],1
    invoke ShowWindow,[hWnd],SW_SHOW
    invoke SetForegroundWindow,[hWnd]
    exit_true
.hide:
    mov [fShow],0
    invoke ShowWindow,[hWnd],SW_HIDE
    exit_true
.vis:
    cmp [fShow],0
    je .exit_true
    invoke SetForegroundWindow,[hWnd]
    exit_true
@@:
;=======================================================================
    cmp [uMsg],WM_INITDIALOG
    jne @F
;-----------------------------------------------------------------------
    invoke CreatePopupMenu
    mov [hMenu],eax
    invoke InsertMenu,[hMenu],-1,MF_BYPOSITION,3,Show
    invoke InsertMenu,[hMenu],-1,MF_BYPOSITION,0,0
    invoke InsertMenu,[hMenu],-1,MF_BYPOSITION,4,Exit
;-----------------------------------------------------------------------
    sub esp,sizeof.RECT
;-----------------------------------------------------------------------
    invoke GetDesktopWindow
    invoke GetClientRect,eax,esp
;-----------------------------------------------------------------------
    sub esp,sizeof.RECT
;-----------------------------------------------------------------------
    invoke GetWindowRect,[hWnd],esp
    mov ecx,[esp + RECT.right]
    sub ecx,[esp + RECT.left]
    mov edx,[esp + RECT.bottom]
    sub edx,[esp + RECT.top]
    mov eax,[esp + sizeof.RECT + RECT.bottom]
    sub [esp + sizeof.RECT + RECT.right],ecx
    sub [esp + sizeof.RECT + RECT.right],32
    sub eax,edx
    shr eax,1
    invoke MoveWindow,[hWnd],\
                 [esp + sizeof.RECT + RECT.right + 4*4],eax,ecx,edx,TRUE
;-----------------------------------------------------------------------
    add esp,sizeof.RECT * 2
;-----------------------------------------------------------------------
    invoke LoadIcon,[hInstance],TRAYICON
    mov [t_data.hIcon],eax
    m2m [t_data.hWnd],[hWnd]
    invoke Shell_NotifyIcon,NIM_ADD,t_data
    exit_true
@@:
;=======================================================================
    cmp [uMsg],WM_COMMAND
    je @F
.exit_false:
    exit_false
@@:    
    cmp word [wParam],B_CAN
    je  .show_hide
    cmp word [wParam],B_EXIT
    je  .destroy
    cmp word [wParam],B_OK
    jne .exit_true
;-----------------------------------------------------------------------
;   TODO
;-----------------------------------------------------------------------
 .exit_true:
    exit_true
;=======================================================================
.menu:
    invoke GetForegroundWindow
    push eax
    invoke SetForegroundWindow,[hWnd]
    sub esp,sizeof.POINT
    invoke GetCursorPos,esp
    pop ecx
    pop edx
    invoke TrackPopupMenuEx,[hMenu],\
        TPM_RIGHTALIGN or TPM_BOTTOMALIGN or \
        TPM_NONOTIFY or TPM_RETURNCMD,\
        ecx,edx,[hWnd],0
    pop edx
    cmp eax,3
    je  .show_hide
    cmp eax,4
    jne  @F
.destroy:  
    invoke Shell_NotifyIcon,NIM_DELETE,t_data
    invoke DestroyMenu,[hMenu]
    invoke EndDialog,[hWnd],0
@@:    
    invoke SetForegroundWindow,edx
    exit_true   
;-----------------------------------------------------------------------
endp
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 section '.data' data readable writeable
;-----------------------------------------------------------------------
t_data              NOTIFYICONDATA sizeof.NOTIFYICONDATA,?,0,\
                        NIF_ICON+NIF_MESSAGE+NIF_TIP,\
                        WM_SHELLNOTIFY,0,"Tray Dialog Demo"
;-----------------------------------------------------------------------
fShow               dd 1
Show                db "Show/Hide",0
Exit                db "Exit",0
;-----------------------------------------------------------------------
 align 4
;-----------------------------------------------------------------------
hInstance           dd ?
hTrayMenu           dd ?
hMenu               dd ?
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
include 'idata.inc' ;*
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
section '.rsrc' resource from '%RC_NAME%.res' data readable
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
