;=======================================================================
format PE GUI 4.0
;=======================================================================
include '%fasminc%\win32a.inc'      ;*
include 'rc.inc'                    ;*
include '..\shoolib\shoomac.inc'    ;*
;-----------------------------------------------------------------------
SUSPENDED equ 555
;=======================================================================
section '.code' code readable executable
;-----------------------------------------------------------------------
entry $
;-----------------------------------------------------------------------
    invoke  GetModuleHandle,0
    mov [hInstance],eax
;-----------------------------------------------------------------------
    invoke GetModuleFileName,0,a_buff,260
    invoke PathRemoveFileSpec,a_buff
    invoke PathAppend,a_buff,ini
    invoke StrDup,a_buff
    mov [p_ini],eax
;-----------------------------------------------------------------------
    invoke DialogBoxParam,[hInstance],D_MAIN,0,dlg_proc,0
;-----------------------------------------------------------------------
    invoke LocalFree,[p_ini]
    invoke ExitProcess,0
;=======================================================================
;
;=======================================================================
winproc dlg_proc
;-----------------------------------------------------------------------
    cmp [uMsg],WM_CLOSE
    jne @F
    cmp [runs],0
    je  .end_dlg
    mov [runs],0
    cmp [h_thread],0
    je  .end_dlg
    invoke WaitForSingleObject,[h_thread],1000
.end_dlg:
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;   Save data
;-----------------------------------------------------------------------
    CSNew 16
    CSAddDec [t_data]
    CSEnd
    lea ecx,[esp + 4]
    invoke WritePrivateProfileString,sect,var,ecx,[p_ini]
    CSFree
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    invoke EndDialog,[hWnd],0
.exit_true:
    mov eax,TRUE
    ret
@@:
;-----------------------------------------------------------------------
    cmp [uMsg],WM_INITDIALOG
    jne @F
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;   Restore data
;-----------------------------------------------------------------------
    invoke GetPrivateProfileInt,sect,var,0,[p_ini]
    mov [t_data],eax
    invoke SetDlgItemInt,[hWnd],EDIT_2,[t_data],0
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    jmp .exit_true
@@:    
;-----------------------------------------------------------------------
    cmp [uMsg],WM_QUERYENDSESSION
    jne @F
    cmp [runs],0
    je  .exit_false
    invoke SendMessage,[hWnd],WM_CLOSE
    jmp .exit_false
@@:    
;-----------------------------------------------------------------------
    cmp [uMsg],WM_COMMAND
    jne .exit_false
    cmp [wParam],B_CAN
    je .end_dlg
;-----------------------------------------------------------------------
    cmp [wParam],B_OK
    jne @F
    cmp [runs],0
    jne .stop
    invoke SetDlgItemText,[hWnd],B_OK,ok_pause
    invoke GetDlgItem,[hWnd],B_CAN
    invoke EnableWindow,eax,FALSE
    mov [runs],1
    cmp [h_thread],0
    jne .resume
    invoke CreateThread,0,0,process,[hWnd],THREAD_PRIORITY_NORMAL,h_thread
    jmp .exit_true
.resume:    
    invoke ResumeThread,[h_thread]
    jmp .exit_true
.stop:
    mov [runs],0
    jmp .exit_true
@@:
;-----------------------------------------------------------------------
    cmp [wParam],SUSPENDED
    jne @F
    invoke SetDlgItemText,[hWnd],B_OK,ok_go
    invoke GetDlgItem,[hWnd],B_CAN
    invoke EnableWindow,eax,TRUE
    jmp .exit_true
@@:
;-----------------------------------------------------------------------
.exit_false:
    xor eax,eax
    ret
endp
;=======================================================================
;
;=======================================================================
include "process.inc"
;-----------------------------------------------------------------------
include  '..\shoolib\shoolib.inc' ;*
;-----------------------------------------------------------------------
if FALSE
 include '..\shoolib\shooimp.inc'
end if
;=======================================================================
;
;=======================================================================
include  'data.inc'
;=======================================================================
;
;=======================================================================
section '.rsrc' resource from 'dialog.res' data readable
;=======================================================================
