;=======================================================================
_bs = 512   ; bytes per sector
_st = 18    ; sectors per track
_hd = 2     ; heads
_tr = 80    ; tracks
_rd = 224   ; root directory entries
_ft = 2     ; fats
_sf = 9     ; sectors per fat
_sc = 1     ; sectors per claster
;=======================================================================
include "fat12.inc"
;=======================================================================
    org 7C00h
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    file "boot.bin"
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    align _bs
    _rs = ($ - 7C00h) / _bs ; calculation of amount of reserved sectors
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;   including files into the image and generating fat.
;   you should check for the first string - file name and extension
;   - it does not checked by macro, thus error can cause unreadable
;   directory entry

    fat12 \ 
        "A       TXT","a.txt",ff0,\
        "B       TXT","b.txt",ff1,\
        "KERNEL  BIN","kernel.bin",ff2
        
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    