;=======================================================================
; DLL Template
;=======================================================================
  format PE GUI 4.0 DLL
; format PE CONSOLE DLL
;=======================================================================
  include 'win32a.inc' ;*                                         
;-----------------------------------------------------------------------
  entry DllEntryPoint
;=======================================================================

section '.code' code readable executable

;-----------------------------------------------------------------------
;   VOID ShowErrorMessage(HWND hWnd,DWORD dwError);
;
proc ShowErrorMessage, hWnd,dwError
    local .lpBuffer: dd ?
    ;--------------------
	lea	eax,[.lpBuffer]
	invoke	FormatMessage,\
	   FORMAT_MESSAGE_ALLOCATE_BUFFER+FORMAT_MESSAGE_FROM_SYSTEM,\
	   0,[dwError],LANG_NEUTRAL,eax,0,0
	invoke	MessageBox,[hWnd],[.lpBuffer],NULL,MB_ICONERROR+MB_OK
	invoke	LocalFree,[.lpBuffer]
	ret
endp

;-----------------------------------------------------------------------
;   VOID ShowLastError(HWND hWnd);
;
proc ShowLastError, hWnd
	invoke	GetLastError
	stdcall ShowErrorMessage,[hWnd],eax
	ret
endp
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
proc DllEntryPoint, hinstDLL,fdwReason,lpvReserved
	mov	eax,TRUE
	ret
endp
;=======================================================================
;
;=======================================================================
include "idata.inc" ;*
;=======================================================================
;
;=======================================================================
section '.edata' export data readable

  export 'ERRORMSG.DLL',\
	 ShowErrorMessage,'ShowErrorMessage',\
	 ShowLastError,'ShowLastError'
;=======================================================================
;
;=======================================================================
section '.reloc' fixups data discardable
;=======================================================================
